// Generated by CoffeeScript 1.8.0
(function() {
  var Model, Query, Schema, debug, mongoose;

  debug = require('debug')('mongoose-plugins-trashable:main');

  mongoose = require('mongoose');

  Model = mongoose.Model;

  Query = mongoose.Query;

  Schema = mongoose.Schema;

  module.exports = function(schema, options) {
    schema.add({
      trashedAt: {
        type: Date,
        "default": null
      },
      trashedBy: {
        type: Schema.Types.ObjectId,
        "default": null
      }
    });
    schema.statics.count = function() {
      return Model.count.apply(this, arguments).where('trashedAt').equals(null);
    };
    schema.statics.countTrashed = function() {
      return Model.count.apply(this, arguments).where('trashedAt').ne(null);
    };
    schema.statics.countWithTrashed = function() {
      return Model.count.apply(this, arguments);
    };
    schema.statics.find = function() {
      return Model.find.apply(this, arguments).where('trashedAt').equals(null);
    };
    schema.statics.findTrashed = function() {
      return Model.find.apply(this, arguments).where('trashedAt').ne(null);
    };
    schema.statics.findWithTrashed = function() {
      return Model.find.apply(this, arguments);
    };
    schema.statics.findOne = function() {
      return Model.findOne.apply(this, arguments).where('trashedAt').equals(null);
    };
    schema.statics.findOneTrashed = function() {
      return Model.findOne.apply(this, arguments).where('trashedAt').ne(null);
    };
    schema.statics.findOneWithTrashed = function() {
      return Model.findOne.apply(this, arguments);
    };
    schema.statics.findById = function(id, fields, options, callback) {
      return this.findOne({
        _id: id
      }, fields, options, callback);
    };
    schema.statics.findTrashedById = function(id, fields, options, callback) {
      return this.findOneTrashed({
        _id: id
      }, fields, options, callback);
    };
    schema.statics.findWithTrashedById = function(id, fields, options, callback) {
      return this.findOneWithTrashed({
        _id: id
      }, fields, options, callback);
    };
    schema.statics.trash = function(conditions, callback) {
      return this.where('trashedAt').equals(null).update(conditions, {
        trashedAt: new Date()
      }, {
        multi: true
      }, callback);
    };
    schema.statics.restore = function(conditions, callback) {
      return this.where('trashedAt').ne(null).update(conditions, {
        trashedAt: null,
        trashedBy: null
      }, {
        multi: true
      }, callback);
    };
    schema.methods.trash = function(callback) {
      var conditions, updates;
      conditions = {
        _id: this.id,
        trashedAt: null
      };
      updates = {
        trashedAt: new Date()
      };
      return this.constructor.findOneAndUpdate(conditions, updates, callback);
    };
    return schema.methods.restore = function(callback) {
      var conditions, updates;
      conditions = {
        _id: this.id,
        trashedAt: {
          $ne: null
        }
      };
      updates = {
        trashedAt: null,
        trashedBy: null
      };
      return this.constructor.findOneAndUpdate(conditions, updates, callback);
    };
  };

  Query.prototype.by = function(instance, callback) {
    var castedDoc, castedQuery, doc, err, options, _ref;
    if (typeof instance === 'function') {
      _ref = [null, instance], instance = _ref[0], callback = _ref[1];
    }
    doc = this._update;
    if (instance != null) {
      doc.trashedBy = instance.id;
    }
    options = void 0;
    castedQuery = void 0;
    castedDoc = void 0;
    try {
      castedQuery = this.cast(this.model);
      castedDoc = this._castUpdate(doc, options != null ? options.overwrite : void 0);
    } catch (_error) {
      err = _error;
      debug(err);
      if (callback != null) {
        callback(err);
        return this;
      } else {
        throw err;
      }
    }
    if (castedQuery._id) {
      return Query.base.findOneAndUpdate.call(this, castedQuery, castedDoc, options, callback);
    } else {
      return Query.base.update.call(this, castedQuery, castedDoc, options, callback);
    }
  };

}).call(this);

//# sourceMappingURL=mongoose-plugins-trashable.js.map
